
module DebugDictExport
    import InPartS: dfopen, dfclose, dfrename, gcreate, isgroup

    dictfs = Dict{String, Any}()

    function dfopen(type::Type{<:Dict}, filename::String; kwargs...)
        allflags = Base.open_flags(;kwargs...)
        # create empty dict if allowed to
        if allflags.create && (allflags.truncate || filename ∉ keys(dictfs))
            dictfs[filename] = Dict{String, Any}()
        end

        return dictfs[filename]
    end

    dfclose(f::Dict) = nothing

    function dfrename(::Type{<:Dict}, oldname, newname; force = false)
        if !force && (newname ∈ keys(dictfs))
            error(newname * " already exists (use force = true to overwrite)")
        end
        dictfs[newname] = pop!(dictfs, oldname)
        return
    end


    function gcreate(group::Dict{String, Any}, key; est_num_entries=2000)
        group[key] = Dict{String, Any}()
    end

    isgroup(group::Dict{String, Any}, key) = group[key] isa Dict{String, Any}

end
